# Cartesian2

#### new Cesium.Cartesian2(x, y)
Core/Cartesian2.js 28

  A 2D Cartesian point.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `x` | Number | `0.0` | optional The X component.
  `y` | Number | `0.0` | optional The Y component.

  ##### See:

  - Cartesian3
  - Cartesian4
  - Packable

### Members

#### x : Number
Core/Cartesian2.js 34

  The X component.
  Default Value: `0.0`

#### y : Number
Core/Cartesian2.js 41

  The Y component.
  Default Value: `0.0`

#### staticCesium.Cartesian2.packedLength : Number
Core/Cartesian2.js 108

  The number of elements used to pack the object into an array.

#### staticconstantCesium.Cartesian2.UNIT_X : Cartesian2
Core/Cartesian2.js 789

  An immutable Cartesian2 instance initialized to (1.0, 0.0).

#### staticconstantCesium.Cartesian2.UNIT_Y : Cartesian2
Core/Cartesian2.js 797

  An immutable Cartesian2 instance initialized to (0.0, 1.0).

#### staticconstantCesium.Cartesian2.ZERO : Cartesian2
Core/Cartesian2.js 781

  An immutable Cartesian2 instance initialized to (0.0, 0.0).

### Methods

#### clone(result) → Cartesian2
Core/Cartesian2.js 805

  Duplicates this Cartesian2 instance.

  Name | Type | Description
  --- | --- | ---
  `result` | Cartesian2 | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

#### equals(right) → Boolean
Core/Cartesian2.js 816

  Compares this Cartesian against the provided Cartesian componentwise and returns `true` if they are equal, `false` otherwise.

  Name | Type | Description
  --- | --- | ---
  `right` | Cartesian2 | optional The right hand side Cartesian.

  ##### Returns:

  `true` if they are equal, `false` otherwise.

#### equalsEpsilon(right, relativeEpsilon, absoluteEpsilon) → Boolean
Core/Cartesian2.js 830

  Compares this Cartesian against the provided Cartesian componentwise and returns `true` if they pass an absolute or relative tolerance test, `false` otherwise.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `right` | Cartesian2 |  | optional The right hand side Cartesian.
  `relativeEpsilon` | Number |  | The relative epsilon tolerance to use for equality testing.
  `absoluteEpsilon` | Number | `relativeEpsilon` | optional The absolute epsilon tolerance to use for equality testing.

  ##### Returns:

  `true` if they are within the provided epsilon, `false` otherwise.

#### toString() → String
Core/Cartesian2.js 839

  Creates a string representing this Cartesian in the format '(x, y)'.

  ##### Returns:

  A string representing the provided Cartesian in the format '(x, y)'.

#### staticCesium.Cartesian2.abs(cartesian, result) → Cartesian2
Core/Cartesian2.js 632

  Computes the absolute value of the provided Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian whose absolute value is to be computed.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.add(left, right, result) → Cartesian2
Core/Cartesian2.js 507

  Computes the componentwise sum of two Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.angleBetween(left, right) → Number
Core/Cartesian2.js 687

  Returns the angle, in radians, between the provided Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.

  ##### Returns:

  The angle between the Cartesians.

#### staticCesium.Cartesian2.clone(cartesian, result) → Cartesian2
Core/Cartesian2.js 69

  Duplicates a Cartesian2 instance.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian to duplicate.
  `result` | Cartesian2 | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided. (Returns undefined if cartesian is undefined)

#### staticCesium.Cartesian2.distance(left, right) → Number
Core/Cartesian2.js 362

  Computes the distance between two points.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first point to compute the distance from.
  `right` | Cartesian2 | The second point to compute the distance to.

  ##### Returns:

  The distance between two points.

  ##### Example:

      // Returns 1.0
      var d = Cesium.Cartesian2.distance(new Cesium.Cartesian2(1.0, 0.0), new Cesium.Cartesian2(2.0, 0.0));

#### staticCesium.Cartesian2.distanceSquared(left, right) → Number
Core/Cartesian2.js 385

  Computes the squared distance between two points. Comparing squared distances using this function is more efficient than comparing distances using `Cartesian2#distance`.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first point to compute the distance from.
  `right` | Cartesian2 | The second point to compute the distance to.

  ##### Returns:

  The distance between two points.

  ##### Example:

      // Returns 4.0, not 2.0
      var d = Cesium.Cartesian2.distance(new Cesium.Cartesian2(1.0, 0.0), new Cesium.Cartesian2(3.0, 0.0));

#### staticCesium.Cartesian2.divideByScalar(cartesian, scalar, result) → Cartesian2
Core/Cartesian2.js 585

  Divides the provided Cartesian componentwise by the provided scalar.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian to be divided.
  `scalar` | Number | The scalar to divide by.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.divideComponents(left, right, result) → Cartesian2
Core/Cartesian2.js 481

  Computes the componentwise quotient of two Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.dot(left, right) → Number
Core/Cartesian2.js 434

  Computes the dot (scalar) product of two Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.

  ##### Returns:

  The dot product.

#### staticCesium.Cartesian2.equals(left, right) → Boolean
Core/Cartesian2.js 740

  Compares the provided Cartesians componentwise and returns `true` if they are equal, `false` otherwise.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | optional The first Cartesian.
  `right` | Cartesian2 | optional The second Cartesian.

  ##### Returns:

  `true` if left and right are equal, `false` otherwise.

#### staticCesium.Cartesian2.equalsEpsilon(left, right, relativeEpsilon, absoluteEpsilon) → Boolean
Core/Cartesian2.js 767

  Compares the provided Cartesians componentwise and returns `true` if they pass an absolute or relative tolerance test, `false` otherwise.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `left` | Cartesian2 |  | optional The first Cartesian.
  `right` | Cartesian2 |  | optional The second Cartesian.
  `relativeEpsilon` | Number |  | The relative epsilon tolerance to use for equality testing.
  `absoluteEpsilon` | Number | `relativeEpsilon` | optional The absolute epsilon tolerance to use for equality testing.

  ##### Returns:

  `true` if left and right are within the provided epsilon, `false` otherwise.

#### staticCesium.Cartesian2.fromArray(array, startingIndex, result) → Cartesian2
Core/Cartesian2.js 235

  Creates a Cartesian2 from two consecutive elements in an array.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `array` | Array.<Number> |  | The array whose two consecutive elements correspond to the x and y components, respectively.
  `startingIndex` | Number | `0` | optional The offset into the array of the first element, which corresponds to the x component.
  `result` | Cartesian2 |  | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

  ##### Example:

      // Create a Cartesian2 with (1.0, 2.0)
      var v = [1.0, 2.0];
      var p = Cesium.Cartesian2.fromArray(v);

      // Create a Cartesian2 with (1.0, 2.0) using an offset into an array
      var v2 = [0.0, 0.0, 1.0, 2.0];
      var p2 = Cesium.Cartesian2.fromArray(v2, 2);

#### staticCesium.Cartesian2.fromCartesian3(cartesian, result) → Cartesian2
Core/Cartesian2.js 91

  Creates a Cartesian2 instance from an existing Cartesian3. This simply takes the x and y properties of the Cartesian3 and drops z.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian3 | The Cartesian3 instance to create a Cartesian2 instance from.
  `result` | Cartesian2 | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

#### staticCesium.Cartesian2.fromCartesian4(cartesian, result) → Cartesian2
Core/Cartesian2.js 102

  Creates a Cartesian2 instance from an existing Cartesian4. This simply takes the x and y properties of the Cartesian4 and drops z and w.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian4 | The Cartesian4 instance to create a Cartesian2 instance from.
  `result` | Cartesian2 | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

#### staticCesium.Cartesian2.fromElements(x, y, result) → Cartesian2
Core/Cartesian2.js 52

  Creates a Cartesian2 instance from x and y coordinates.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The x coordinate.
  `y` | Number | The y coordinate.
  `result` | Cartesian2 | optional The object onto which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

#### staticCesium.Cartesian2.lerp(start, end, t, result) → Cartesian2
Core/Cartesian2.js 657

  Computes the linear interpolation or extrapolation at t using the provided cartesians.

  Name | Type | Description
  --- | --- | ---
  `start` | Cartesian2 | The value corresponding to t at 0.0.
  `end` | Cartesian2 | The value corresponding to t at 1.0.
  `t` | Number | The point along t at which to interpolate.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.magnitude(cartesian) → Number
Core/Cartesian2.js 345

  Computes the Cartesian's magnitude (length).

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian instance whose magnitude is to be computed.

  ##### Returns:

  The magnitude.

#### staticCesium.Cartesian2.magnitudeSquared(cartesian) → Number
Core/Cartesian2.js 329

  Computes the provided Cartesian's squared magnitude.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian instance whose squared magnitude is to be computed.

  ##### Returns:

  The squared magnitude.

#### staticCesium.Cartesian2.maximumByComponent(first, second, result) → Cartesian2
Core/Cartesian2.js 305

  Compares two Cartesians and computes a Cartesian which contains the maximum components of the supplied Cartesians.

  Name | Type | Description
  --- | --- | ---
  `first` | Cartesian2 | A cartesian to compare.
  `second` | Cartesian2 | A cartesian to compare.
  `result` | Cartesian2 | The object into which to store the result.

  ##### Returns:

  A cartesian with the maximum components.

#### staticCesium.Cartesian2.maximumComponent(cartesian) → Number
Core/Cartesian2.js 243

  Computes the value of the maximum component for the supplied Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The cartesian to use.

  ##### Returns:

  The value of the maximum component.

#### staticCesium.Cartesian2.minimumByComponent(first, second, result) → Cartesian2
Core/Cartesian2.js 277

  Compares two Cartesians and computes a Cartesian which contains the minimum components of the supplied Cartesians.

  Name | Type | Description
  --- | --- | ---
  `first` | Cartesian2 | A cartesian to compare.
  `second` | Cartesian2 | A cartesian to compare.
  `result` | Cartesian2 | The object into which to store the result.

  ##### Returns:

  A cartesian with the minimum components.

#### staticCesium.Cartesian2.minimumComponent(cartesian) → Number
Core/Cartesian2.js 259

  Computes the value of the minimum component for the supplied Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The cartesian to use.

  ##### Returns:

  The value of the minimum component.

#### staticCesium.Cartesian2.mostOrthogonalAxis(cartesian, result) → Cartesian2
Core/Cartesian2.js 710

  Returns the axis that is most orthogonal to the provided Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian on which to find the most orthogonal axis.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The most orthogonal axis.

#### staticCesium.Cartesian2.multiplyByScalar(cartesian, scalar, result) → Cartesian2
Core/Cartesian2.js 559

  Multiplies the provided Cartesian componentwise by the provided scalar.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian to be scaled.
  `scalar` | Number | The scalar to multiply with.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.multiplyComponents(left, right, result) → Cartesian2
Core/Cartesian2.js 455

  Computes the componentwise product of two Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.negate(cartesian, result) → Cartesian2
Core/Cartesian2.js 610

  Negates the provided Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian to be negated.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.normalize(cartesian, result) → Cartesian2
Core/Cartesian2.js 403

  Computes the normalized form of the supplied Cartesian.

  Name | Type | Description
  --- | --- | ---
  `cartesian` | Cartesian2 | The Cartesian to be normalized.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.pack(value, array, startingIndex) → Array.<Number>
Core/Cartesian2.js 119

  Stores the provided instance into the provided array.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `value` | Cartesian2 |  | The value to pack.
  `array` | Array.<Number> |  | The array to pack into.
  `startingIndex` | Number | `0` | optional The index into the array at which to start packing the elements.

  ##### Returns:

  The array that was packed into

#### staticCesium.Cartesian2.packArray(array, result) → Array.<Number>
Core/Cartesian2.js 169

  Flattens an array of Cartesian2s into and array of components.

  Name | Type | Description
  --- | --- | ---
  `array` | Array.<Cartesian2> | The array of cartesians to pack.
  `result` | Array.<Number> | The array onto which to store the result.

  ##### Returns:

  The packed array.

#### staticCesium.Cartesian2.subtract(left, right, result) → Cartesian2
Core/Cartesian2.js 533

  Computes the componentwise difference of two Cartesians.

  Name | Type | Description
  --- | --- | ---
  `left` | Cartesian2 | The first Cartesian.
  `right` | Cartesian2 | The second Cartesian.
  `result` | Cartesian2 | The object onto which to store the result.

  ##### Returns:

  The modified result parameter.

#### staticCesium.Cartesian2.unpack(array, startingIndex, result) → Cartesian2
Core/Cartesian2.js 145

  Retrieves an instance from a packed array.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `array` | Array.<Number> |  | The packed array.
  `startingIndex` | Number | `0` | optional The starting index of the element to be unpacked.
  `result` | Cartesian2 |  | optional The object into which to store the result.

  ##### Returns:

  The modified result parameter or a new Cartesian2 instance if one was not provided.

#### staticCesium.Cartesian2.unpackArray(array, result) → Array.<Cartesian2>
Core/Cartesian2.js 196

  Unpacks an array of cartesian components into and array of Cartesian2s.

  Name | Type | Description
  --- | --- | ---
  `array` | Array.<Number> | The array of components to unpack.
  `result` | Array.<Cartesian2> | The array onto which to store the result.

  ##### Returns:

  The unpacked array.